do
    local dbmCmdHandler = SlashCmdList["DEADLYBOSSMODS"];
    if dbmCmdHandler == nil then return end
	
	local rings = {
		["TANK"] = 124637,
		["DAMAGER-INT"] = 124635,
		["DAMAGER-AGI"] = 124636,
		["DAMAGER-STR"] = 124634,
		["HEALER"] = 124638
	}

    SlashCmdList["DEADLYBOSSMODS"] = function(msg, ...)
		local function PrintMessage(message)
			local coloredmessage = ORANGE_FONT_COLOR_CODE.."LegendaryDummy!"..FONT_COLOR_CODE_CLOSE.." "..message
			DBM:AddMsg(RED_FONT_COLOR_CODE .. ">>> " .. FONT_COLOR_CODE_CLOSE .. coloredmessage .. RED_FONT_COLOR_CODE .. " <<<" .. FONT_COLOR_CODE_CLOSE)
		end
		
		local function GetItemIdFromLink(link)
			if(link) then
				return select(3, strfind(link, "item:(%d+)"))
			end
		end
		
		local function ScanBagsForItem(itemId)
			for b=0,NUM_BAG_SLOTS do 
				for s = 1, GetContainerNumSlots(b) do 
					local link = GetContainerItemLink(b, s)
					local id = GetItemIdFromLink(link)
					if(id == tostring(itemId)) then
						return link
					end
				end 
			end
		end
		
		local function ScanCharacterForItem(itemId)
			for _,slot in pairs({INVSLOT_FINGER1, INVSLOT_FINGER2}) do
				local link = GetInventoryItemLink("player", slot)
				local id = GetItemIdFromLink(link)
				if(id == tostring(itemId)) then
					return link
				end
			end
		end
		
       	local cmd = msg:lower()
        if cmd:sub(1, 4) == "pull" then
			-- what is my current role?
			local currentRole = UnitGroupRolesAssigned("player")
			-- UnitGroupRolesAssigned only works when grouped
			-- we only really care when we're grouped anyway, I doubt anyone would ever call /dbm pull solo
			if (currentRole ~= nil and currentRole ~= "NONE") then
				local enhancedRole = currentRole
				-- what is my current preferred stat (only important for DAMAGER role)
				if(currentRole == "DAMAGER") then
					local _, str = UnitStat("player", 1);
					local _, agi = UnitStat("player", 2);
					local _, int = UnitStat("player", 4);
					if(str > agi and str > int) then
						enhancedRole = enhancedRole.. "-STR"
					elseif(agi > str and agi > int) then
						enhancedRole = enhancedRole.. "-AGI"
					else
						enhancedRole = enhancedRole.. "-INT"
					end
				end
				
				-- this is the legendary ring we should be expected to wear
				local myLegendaryRing = rings[enhancedRole]

				-- show a warning if I don't have the legendary ring equipped but I have it my bags
				if(not IsEquippedItem(myLegendaryRing) and GetItemCount(myLegendaryRing, false) > 0 ) then
					local link = ScanBagsForItem(myLegendaryRing)
					PrintMessage("Equip your legendary ring (it's in your bags)! "..link)
				else
					-- what if we only bought one legendary ring and we have it equipped but it doesn't match our chosen role
					local otherRingEquipped = false
					for _, otherRing in pairs(rings) do
						if(not otherRingEquipped and otherRing ~= myLegendaryRing and IsEquippedItem(otherRing))then
							otherRingEquipped = true
							local link = ScanCharacterForItem(otherRing)
							PrintMessage("Equipped ring "..link .. " does not match your chosen role.")
						end
					end
				end
			end
        end
        return dbmCmdHandler(msg, ...)
    end
end